package jp.ameba.sp.app {
	import flash.display.*;
	import flash.events.*;
	import flash.media.*;
	import flash.system.*;
	import flash.text.*;
	import flash.utils.*;
	
	import jp.ameba.sp.app.controller.*;
	
	/**
	 * すべてのボタン機能の設定と戻るボタンの設定を持つクラスです.
	 */
	public class SampleMain extends MovieClip {
		/* Stageへの参照変数. */
		private static var _myStage:Stage;
		/*このクラスのインスタンス.*/
		private static var _myInstance:SampleMain;
		
		///// 各機能のクラスのインスタンス
		/*プリインストールカメラ操作用のクラス.*/
		var _myCamera:CameraController;
		/*デバイスカメラを操作するクラス.*/
		var _myCameraViewController:CameraViewController;
		/*カメラロールを操作するクラス.*/
		var _myCameraRollController:CameraRollController;
		/*加速度センサー操作用のクラス.*/
		var _myAccelerometer:AccelerometerController;
		/*GPS機能操作用のクラス.*/
		var _myGeoLocationController:GeoLocationController;
		/*GoogleMap操作用のクラス.*/
		var _myGoogleMapController:GoogleMapController;
		
		///// 各ボタンのインスンタンス.
		/*ボタンの置いてあるMC.*/
		var _buttonArea_mc:MovieClip;
		/*カメラ呼び出しボタンのインスタンス.*/
		var _cameraBtn:MovieClip;
		/*カメラ使用ボタンのインスタンス.*/
		var _cameraViewBtn:MovieClip;
		/*カメラロール参照ボタンのインスタンス.*/
		var _cameraRollBtn:MovieClip;
		
		/*加速度センサーボタンのインスタンス.*/
		var _accelBtn:MovieClip;
		/*GPS機能のボタンのインスタンス.*/
		var _geoBtn:MovieClip;
		/*GoogleMap起動ボタンのインスタンス.*/
		var _googleMapBtn:MovieClip;
		
		/*戻るボタン.*/
		var _backBtn:MovieClip;
		/*Loading.*/
		var _loading:MovieClip;
		
		
		
		public static var MARGIN_LEFT:Number = 20;
		public static var MARGIN_TOP:Number = 100;
		
		/**
		 * コンストラクタ.
		 */
		public function SampleMain() {
			// Stageへの参照
			_myStage = this.stage;
			_myInstance = this;                
			_myStage.align = StageAlign.TOP_LEFT;
			//_myStage.scaleMode = StageScaleMode.NO_SCALE;
			
			// 各機能のクラスを初期化
			_myCamera = new CameraController();
			_myCameraViewController = new CameraViewController();
			_myCameraRollController = new CameraRollController();
			
			_myAccelerometer = new AccelerometerController();
			_myGeoLocationController = new GeoLocationController();
			_myGoogleMapController = new GoogleMapController();
			
			// ロードチェック
			_myStage.addEventListener(Event.ENTER_FRAME, loadCheck);
		}
		
		
		/**
		 * ロード状況をチェックする.
		 * @param evt EnterFrameイベント
		 */
		function loadCheck(evt:Event) {
			if (evt.target.loaderInfo.bytesTotal == evt.target.loaderInfo.bytesLoaded) {
				evt.target.removeEventListener(Event.ENTER_FRAME, loadCheck);
				setUpScreen();
			}
		}
		
		/**
		 * 画面の設定を行う.
		 */
		function setUpScreen() {
			// ボタンエリアへの参照
			_buttonArea_mc = this.getChildByName("buttonArea_mc") as MovieClip;
			
			// カメラ起動ボタン
			_cameraBtn = _buttonArea_mc.getChildByName("cameraBtn") as MovieClip;
			// カメラviewボタン
			_cameraViewBtn = _buttonArea_mc.getChildByName("cameraViewBtn") as MovieClip;
			// カメラロールボタン
			_cameraRollBtn = _buttonArea_mc.getChildByName("cameraRollBtn") as MovieClip;
			
			// 加速度センサーボタン
			_accelBtn = _buttonArea_mc.getChildByName("accelBtn") as MovieClip;
			// GPS機能ボタン
			_geoBtn = _buttonArea_mc.getChildByName("geoBtn") as MovieClip;
			// GoogleMapボタン
			_googleMapBtn = _buttonArea_mc.getChildByName("googleMapBtn") as MovieClip;
			
			// 戻るボタン(リンケージ名:backBtn)
			var backBtnClass:Class = Class(getDefinitionByName("backBtn"));
			_backBtn = new backBtnClass();
			// Loading
			var loadingClass:Class = Class(getDefinitionByName("loading"));
			_loading = new loadingClass();
			
			
			createButtonAction();
		}
		
		/**
		 * 各ボタンのアクションを定義.
		 */
		function createButtonAction() {
			// カメラボタンのイベントを設定
			_cameraBtn.addEventListener(MouseEvent.CLICK, cameraBtnHandler);
			// viewボタンのイベントを設定
			_cameraViewBtn.addEventListener(MouseEvent.CLICK, cameraViewBtnHandler);
			// カメラロールボタンのイベントを設定
			_cameraRollBtn.addEventListener(MouseEvent.CLICK, cameraRollBtnHandler);
			
			// 加速度センサーボタンのイベントを設定
			_accelBtn.addEventListener(MouseEvent.CLICK, accelBtnHandler);
			// GPS機能ボタンのイベントを設定
			_geoBtn.addEventListener(MouseEvent.CLICK, geoBtnHandler);
			// GoogleMapボタンのイベントを設定
			_googleMapBtn.addEventListener(MouseEvent.CLICK, googleMapBtnHandler);
		}
		
		/**
		 * ボタンのイベントを削除する.
		 */
		function removeButonAction() {
			_cameraBtn.removeEventListener(MouseEvent.CLICK, cameraBtnHandler);
			_cameraViewBtn.removeEventListener(MouseEvent.CLICK, cameraViewBtnHandler);
			_cameraRollBtn.removeEventListener(MouseEvent.CLICK, cameraRollBtnHandler);
			
			_accelBtn.removeEventListener(MouseEvent.CLICK, accelBtnHandler);
			_geoBtn.removeEventListener(MouseEvent.CLICK, geoBtnHandler);
			_googleMapBtn.removeEventListener(MouseEvent.CLICK, googleMapBtnHandler);
		}
		/**
		 * カメラボタンを押した時の処理.
		 * @param evt クリックイベント
		 */
		function cameraBtnHandler(evt:MouseEvent) {
			MovieClip(evt.target).gotoAndPlay("tap");
			removeButonAction();
			hideButtons();
			_myCamera.startUp();
		}
		/**
		 * カメラビューボタンを押した時の処理.
		 * @param evt クリックイベント
		 */
		function cameraViewBtnHandler(evt:MouseEvent) {
			MovieClip(evt.target).gotoAndPlay("tap");
			removeButonAction();
			hideButtons();
			_myCameraViewController.startUp();
		}
		/**
		 * カメラロールボタンを押した時の処理.
		 * @param evt クリックイベント
		 */
		function cameraRollBtnHandler(evt:MouseEvent) {
			MovieClip(evt.target).gotoAndPlay("tap");
			removeButonAction();
			hideButtons();
			_myCameraRollController.startUp();
		}
		/**
		 * 加速度センサーボタンを押した時の処理.
		 * @param evt クリックイベント
		 */
		function accelBtnHandler(evt:MouseEvent) {
			MovieClip(evt.target).gotoAndPlay("tap");
			removeButonAction();
			hideButtons();
			_myAccelerometer.startUp();
		}
		/**
		 * GPS機能ボタンを押した時の処理.
		 * @param evt クリックイベント
		 */
		function geoBtnHandler(evt:MouseEvent) {
			MovieClip(evt.target).gotoAndPlay("tap");
			removeButonAction();
			hideButtons();
			_myGeoLocationController.startUp();
		}
		/**
		 * GoogleMapボタンを押した時の処理.
		 */
		function googleMapBtnHandler(evt:MouseEvent) {
			MovieClip(evt.target).gotoAndPlay("tap");
			removeButonAction();
			hideButtons();
			_myGoogleMapController.startUp();
		}
		
		/**
		 * 機能ボタンを表示する.
		 */
		public function showButtons() {
			createButtonAction();
			this.gotoAndPlay("up");	
		}
		/**
		 * 機能ボタンを隠す.
		 */
		public function hideButtons() {
			this.gotoAndPlay("down");
		}
		
		/**
		 * 各機能からの戻るボタンの設定.
		 * @param func 戻るボタンを押した時に実行するファンクション
		 */
		public function setBackBtnAction(func:Function) {
			_myStage.addChildAt(_backBtn, _myStage.numChildren);
			
			_backBtn.x = (_myStage.stageWidth-_backBtn.width)/2;
			_backBtn.y = _myStage.stageHeight -_backBtn.height-MARGIN_TOP;
			_backBtn.addEventListener(MouseEvent.CLICK, func);
		}
		
		/**
		 * 戻るボタンを押した時の処理.
		 */
		public function backBtnAction() {
			_myStage.removeChild(_backBtn);
			showButtons();
		}
		/**
		 * Loadingを配置する.
		 */
		public function addLoading() {
			this.stage.addChildAt(_loading, _myStage.numChildren);
			_loading.x = (_myStage.stageWidth - _loading.width)/2 + _loading.width/2;
			_loading.y = (_myStage.stageHeight - _loading.height)/2 + _loading.height/2;
		}
		/**
		 * Loadingを消す.
		 */
		public function removeLoading() {
			_myStage.removeChild(_loading);
		}
		
		
		/**
		 * このクラスのインスタンスを返す.
		 * 万が一インスタンスが生成されていない場合は作成する.
		 * @return このクラスのインスタンス
		 */
		public static function getInstance():SampleMain { 
			if (_myInstance == null) {
				_myInstance = new SampleMain();
			}
			return _myInstance;
		}
		/**
		 * ステージへの参照を返す.
		 * @return ステージへの参照.
		 */
		public function getStage():Stage {
			if (_myStage == null) {
				_myStage = getInstance().stage as Stage;
			}
			return _myStage;
		}
	}
}