package jp.ameba.sp.app.controller
{
	import flash.display.*;
	import flash.events.*;
	import flash.net.*;
	import flash.sensors.*;
	
	import jp.ameba.sp.app.SampleMain;
	
	/**
	 * デバイスのGoogleMapを起動して表示します.
	 * 今回はシンプルに現在地を表示するのみです.
	 */
	public class GoogleMapController
	{
		/*メインクラス.*/
		var _main:SampleMain;
		/*位置情報クラス.*/
		var _myGeolocation:Geolocation;
		
		/**
		 * コンストラクタ.
		 */
		public function GoogleMapController()
		{
			_main = SampleMain.getInstance();
		}
		/**
		 * GoogleMapを起動する準備をします.
		 */
		public function startUp() {
			_main.addLoading();
			_main.setBackBtnAction(backBtnHandler);
			_myGeolocation = new Geolocation();
			// 更新頻度を設定
			_myGeolocation.setRequestedUpdateInterval(1000);
			// 更新イベントを設定
			_myGeolocation.addEventListener(GeolocationEvent.UPDATE, googleGeolocationHandler);
		}
		
		/**
		 * GoogleMap表示から戻る.
		 * (backボタン用)
		 */
		public function backBtnHandler(evt:MouseEvent) {
			_main.backBtnAction();
		}
		
		/**
		* GPSの位置情報が更新された時に呼び出される処理.
		* 更新された位置のGoogleMapを表示する.
		* @param evt 位置情報更新のイベント
		*/
		function googleGeolocationHandler(evt:GeolocationEvent) {
			_main.removeLoading();
			_myGeolocation.removeEventListener(GeolocationEvent.UPDATE, googleGeolocationHandler);
			// 経度
			var long:Number = evt.longitude;
			// 緯度
			var lat:Number = evt.latitude;
			// GoogleMap
			navigateToURL(new URLRequest("http://maps.google.co.jp/maps?ll=" +lat+","+long + "&z=18&hl=ja"));
		}
	}
}